package wsq_sun_java;

import java.awt.*;
import java.awt.image.*;
import java.io.*;
import javax.swing.*;
import javax.swing.filechooser.FileNameExtensionFilter;


public class NewJDialog extends javax.swing.JDialog {

    private int width, height, ppi;
    String comment_text;
    private int[] imageProperties = new int[3]; 
    double bitrate;
    private byte[] input_data_stream, output_data_stream, input_data_stream2, output_data_stream2;        

    DirectColorModel colorModel;
    DataBuffer dataBuffer;        
    int[] bandMasks;
    int[] dimension;
    int[] data;


	FileNameExtensionFilter All_Images_Filter;	
	FileNameExtensionFilter WSQ_Filter;
	FileNameExtensionFilter BMP_Filter;
	FileNameExtensionFilter TIFF_Filter;
	FileNameExtensionFilter TIF_Filter;
	FileNameExtensionFilter JPEG_Filter;
	FileNameExtensionFilter JPG_Filter;
	FileNameExtensionFilter JP2_Filter;
	FileNameExtensionFilter JPC_Filter;
	FileNameExtensionFilter PNG_Filter;
	FileNameExtensionFilter GIF_Filter;
	FileNameExtensionFilter TGA_Filter;
	FileNameExtensionFilter PCX_Filter;
	FileNameExtensionFilter ICO_Filter;
	FileNameExtensionFilter WMF_Filter;
	FileNameExtensionFilter EMF_Filter;
	FileNameExtensionFilter WBM_Filter;
	FileNameExtensionFilter WBMP_Filter;
	FileNameExtensionFilter SKA_Filter;
	FileNameExtensionFilter MNG_Filter;
	FileNameExtensionFilter JNG_Filter;
	FileNameExtensionFilter PNM_Filter;
	FileNameExtensionFilter PBM_Filter;
	FileNameExtensionFilter PGM_Filter;
	FileNameExtensionFilter PPM_Filter;
	FileNameExtensionFilter RAS_Filter;
	FileNameExtensionFilter RAW_Filter;
	FileNameExtensionFilter CRW_Filter;
	FileNameExtensionFilter CR2_Filter;
	FileNameExtensionFilter DNG_Filter;
	FileNameExtensionFilter ARW_Filter;
	FileNameExtensionFilter ERF_Filter;
	FileNameExtensionFilter F3FR_Filter;
	FileNameExtensionFilter DCRF_Filter;
	FileNameExtensionFilter X3F_Filter;
	FileNameExtensionFilter MEF_Filter;
	FileNameExtensionFilter RAF_Filter;
	FileNameExtensionFilter MRW_Filter;
	FileNameExtensionFilter PEF_Filter;
	FileNameExtensionFilter SR2_Filter;
	FileNameExtensionFilter ORF_Filter;

    
    
    /** Creates new form NewJDialog */
    public NewJDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        
        comment_text = null;  // //need to initialize comment_text in order to avoid crashing      
        colorModel = new DirectColorModel(32, 0x00ff0000, 0x0000ff00, 0x000000ff );
        bandMasks = new int[] { 0x00ff0000, 0x0000ff00, 0x000000ff };
        dimension = new int[2];
        
        m_wsqDemo = new WSQ_Demo();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jFrame1 = new javax.swing.JFrame();
        m_label = new javax.swing.JLabel();
        buttonOpen = new javax.swing.JButton();
        buttonSave = new javax.swing.JButton();
        buttonRegister = new javax.swing.JButton();
        buttonwsq_to_stream = new javax.swing.JButton();
        buttonstream_to_wsq = new javax.swing.JButton();
		
		
All_Images_Filter = new FileNameExtensionFilter("All Images", "wsq", "bmp", "tiff", "tif", "jpeg", "jpg", "jp2", "jpc", "png", "gif", "tga", "pcx", "ico", "wmf", "emf", "wbm", "wbpm", "ska", "mng", "jng", "pnm", "pbm", "pgm", "ppm");

WSQ_Filter = new FileNameExtensionFilter("FBI Wavelet Scalar Quantization (*.wsq)", "wsq");	
BMP_Filter = new FileNameExtensionFilter("Windows Bitmap Graphics (*.bmp)", "bmp");
TIFF_Filter = new FileNameExtensionFilter("Macintosh Tagged Information File Format images (*.tiff)", "tiff");
TIF_Filter = new FileNameExtensionFilter("PC Tagged Information File Format images (*.tif)", "tif");
JPEG_Filter = new FileNameExtensionFilter("Joint Photographic Experts Group images (*.jpeg)", "jpeg");
JPG_Filter = new FileNameExtensionFilter("Joint Photographic Experts Group images (*.jpg)", "jpg");
JP2_Filter = new FileNameExtensionFilter("JPEG2000 Part 1 images (*.jp2)", "jp2");
JPC_Filter = new FileNameExtensionFilter("JPEG2000 Code Stream images (*.jpc)", "jpc");
PNG_Filter = new FileNameExtensionFilter("Portable Network Graphics images (*.png)", "png");
GIF_Filter = new FileNameExtensionFilter("Compuserve Graphic Interchange Format images (*.gif)", "gif");
TGA_Filter = new FileNameExtensionFilter("Truevision Targa Graphic images (*.tga)", "tga");
PCX_Filter = new FileNameExtensionFilter("ZSoft Paintbrush images (PC Paintbrush Bitmap Graphic) (*.pcx)", "pcx");
ICO_Filter = new FileNameExtensionFilter("Windows Icons (*.ico)", "ico");
WMF_Filter = new FileNameExtensionFilter("Windows Metafiles (*.wmf)", "wmf");
EMF_Filter = new FileNameExtensionFilter("Windows Metafiles (*.emf)", "emf");
WBM_Filter = new FileNameExtensionFilter("Wireless Bitmap File Format images (*.wbm)", "wbm");
WBMP_Filter = new FileNameExtensionFilter("Wireless Bitmap File Format images (*.wbpm)", "wbpm");
SKA_Filter = new FileNameExtensionFilter("SKA Format images (*.ska)", "ska");
MNG_Filter = new FileNameExtensionFilter("Multiple Network Graphics (*.mng)", "mng");
JNG_Filter = new FileNameExtensionFilter(" JPEG Network Graphic (*.jng)", "jng");
PNM_Filter = new FileNameExtensionFilter("Portable Any Map images (*.pnm)", "pnm");
PBM_Filter = new FileNameExtensionFilter("Portable Bitmap Format images (*.pbm)", "pbm");
PGM_Filter = new FileNameExtensionFilter("Portable Graymap Format images (*.pgm)", "pgm");
PPM_Filter = new FileNameExtensionFilter("Portable Pixmap Format images (*.ppm)", "ppm");
RAS_Filter = new FileNameExtensionFilter("Sun Graphic (*.ras)", "ras");
RAW_Filter = new FileNameExtensionFilter("RAW Graphic (*.raw)", "raw");
CRW_Filter = new FileNameExtensionFilter("CRW RAW Graphic (*.crw)", "crw");
CR2_Filter = new FileNameExtensionFilter("CR2 RAW Graphic (*.cr2)", "cr2");	
DNG_Filter = new FileNameExtensionFilter("DNG RAW Graphic (*.dng)", "dng");
ARW_Filter = new FileNameExtensionFilter("ARW RAW Graphic (*.arw)", "arw");
ERF_Filter = new FileNameExtensionFilter("ERF RAW Graphic (*.erf)", "erf");
F3FR_Filter = new FileNameExtensionFilter("3FR RAW Graphic (*.3fr)", "3fr");
DCRF_Filter = new FileNameExtensionFilter("DCR RAW Graphic (*.dcr)", "dcr");
X3F_Filter = new FileNameExtensionFilter("X3F RAW Graphic (*.x3f)", "x3f");
MEF_Filter = new FileNameExtensionFilter("MEF RAW Graphic (*.mef)", "mef");
RAF_Filter = new FileNameExtensionFilter("RAF RAW Graphic (*.raf)", "raf");
MRW_Filter = new FileNameExtensionFilter("MRW RAW Graphic (*.mrw)", "mrw");
PEF_Filter = new FileNameExtensionFilter("PEF RAW Graphic (*.pef)", "pef");
SR2_Filter = new FileNameExtensionFilter("SR2 RAW Graphic (*.sr2)", "sr2");
ORF_Filter = new FileNameExtensionFilter("ORF RAW Graphic (*.orf)", "orf");	
		
		
		
        org.jdesktop.layout.GroupLayout jFrame1Layout = new org.jdesktop.layout.GroupLayout(jFrame1.getContentPane());
        jFrame1.getContentPane().setLayout(jFrame1Layout);
        jFrame1Layout.setHorizontalGroup(
            jFrame1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 400, Short.MAX_VALUE)
        );
        jFrame1Layout.setVerticalGroup(
            jFrame1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 300, Short.MAX_VALUE)
        );

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        m_label.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);

        buttonOpen.setText("Open");
        buttonOpen.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonOpenActionPerformed(evt);
            }
        });

        buttonSave.setText("Save");
        buttonSave.setEnabled(false);
        buttonSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonSaveActionPerformed(evt);
            }
        });

        buttonRegister.setText("Register");
        buttonRegister.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonRegisterActionPerformed(evt);
            }
        });

        buttonwsq_to_stream.setText("wsq -> stream");
        buttonwsq_to_stream.setActionCommand("wsq_to_stream");
        buttonwsq_to_stream.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonwsq_to_streamActionPerformed(evt);
            }
        });

        buttonwsq_to_stream.getAccessibleContext().setAccessibleName("wsq_to_stream");

        buttonstream_to_wsq.setText("stream -> wsq");
        buttonstream_to_wsq.setActionCommand("stream_to_wsq");
        buttonstream_to_wsq.setEnabled(false);
        buttonstream_to_wsq.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonstream_to_wsqActionPerformed(evt);
            }
        });

        buttonstream_to_wsq.getAccessibleContext().setAccessibleName("stream_to_wsq");

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(buttonOpen)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(buttonSave)
						.addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
						.add(buttonRegister))
                    .add(layout.createSequentialGroup()
                        .add(buttonwsq_to_stream)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(buttonstream_to_wsq))
                    .add(layout.createSequentialGroup()
                        .addContainerGap()
                        .add(m_label)))
                .addContainerGap(117, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(buttonwsq_to_stream)
                    .add(buttonstream_to_wsq))
                .add(19, 19, 19)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(buttonOpen)
                    .add(buttonSave)
					.add(buttonRegister))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(m_label)
                .addContainerGap(225, Short.MAX_VALUE))
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void buttonstream_to_wsqActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonstream_to_wsqActionPerformed

        System.out.println("button stream to wsq action");
        
        JFileChooser saveDlg = new JFileChooser();
        
        saveDlg.setCurrentDirectory(new File(lastSaveFolder));
		saveDlg.setFileFilter(WSQ_Filter);
		
        
        int dialogResult = saveDlg.showSaveDialog(this);
        
        if(dialogResult != JFileChooser.APPROVE_OPTION) {
            return;
        }
        lastSaveFolder = saveDlg.getSelectedFile().getParent();
        
        String fileName = saveDlg.getSelectedFile().getAbsolutePath();
        
        try {
        

        bitrate = 0.75; 
        comment_text = "Cognaxon";
        int row, row2, pixel_number, pixel_number2;

        input_data_stream2 = new byte[width*height];
        
	// BEGIN --> MAKE A MIRRORED/FLIPPED IMAGE (UP<->DOWN and LEFT<->RIGHT)
        for (int y = 0; y < height; y++)
        {
               row = width * y;
    	       row2 = width * (height - y - 1);
            for (int x = 0;  x < width; x++)
            {
             pixel_number = row + x;
	     pixel_number2 = row2 + (width - x - 1);

             input_data_stream2[pixel_number2] = output_data_stream[pixel_number];
            }
        }
        // END --> MAKE A MIRRORED/FLIPPED IMAGE (UP<->DOWN and LEFT<->RIGHT)        
    

        output_data_stream2 =  WSQ_Demo.WSQ_encode_stream(input_data_stream2, width, height, bitrate, ppi, comment_text);

        fileName = fileName + ".wsq";
        FileOutputStream output_file_stream = new FileOutputStream(fileName);
        output_file_stream.write(output_data_stream2);
        output_file_stream.close();        
        
        JOptionPane.showMessageDialog(null, "Memory stream was compressed into another memory stream and saved to WSQ file.\nNow please press button \"Open\", select the saved file, open it and have a look at the\nresults of memory stream processing. The processed image is mirrored/flipped\n(UP<->DOWN and LEFT<->RIGHT).", "WSQ Image Library", JOptionPane.INFORMATION_MESSAGE);
        
        
        } catch (Exception e) {
            System.out.println(e.toString());
        }        
        
    }//GEN-LAST:event_buttonstream_to_wsqActionPerformed

    private void buttonwsq_to_streamActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonwsq_to_streamActionPerformed
        
        System.out.println("button wsq_to_stream action");
        
        JFileChooser openDlg = new JFileChooser();
        openDlg.setCurrentDirectory(new File(lastOpenFolder));
		openDlg.setFileFilter(WSQ_Filter);        

 
        int dialogResult = openDlg.showOpenDialog(this);
        
        if(dialogResult != JFileChooser.APPROVE_OPTION) {
            return;
        }
        lastOpenFolder = openDlg.getSelectedFile().getParent();
        String fileName = openDlg.getSelectedFile().getAbsolutePath();
             
        System.out.println(fileName);
        try {
		
        FileInputStream input_file_stream = new FileInputStream(fileName);        
        input_data_stream = new byte[input_file_stream.available()];
        //noinspection ResultOfMethodCallIgnored
        input_file_stream.read(input_data_stream);
        input_file_stream.close();        
        
	
        output_data_stream =  WSQ_Demo.WSQ_decode_stream(input_data_stream, imageProperties);
        width = imageProperties[0]; 
        height = imageProperties[1];
        ppi = imageProperties[2];    

       System.out.println("width = " + width + ", height = " + height + ", ppi = " + ppi);
        
       
        //Converts WSQ compressed byte array into HBITMAP for showing on screen
        dimension[0] = 0;
        dimension[1] = 0;
        data = WSQ_Demo.CreateBMPFromWSQByteArray(dimension, input_data_stream);
        // Saves WSQ compressed byte array to an image file.
        //WSQ_Demo.SaveWSQByteArrayToImageFile(input_data_stream, "C:\\OutputDirectory\\output.jpg", 5);
        
        
        width = dimension[0];
        height = dimension[1];
        
        try {       
        
        dataBuffer = new DataBufferInt(data, data.length);
        
        WritableRaster writableRaster = Raster.createPackedRaster(dataBuffer, width, height, width, bandMasks, null);
        m_image = new BufferedImage(colorModel, writableRaster, true, null);
        javax.swing.ImageIcon ii = new javax.swing.ImageIcon(m_image);
        m_label.setIcon(ii);

//        JOptionPane.showMessageDialog(null, "WSQ file was loaded into memory stream and decompressed into another memory stream.\nNow please press button \"stream -> WSQ\" to compress memory stream and save it to file.\nWSQ compressed byte array was converted to HBITMAP for showing on screen.", "WSQ Image Library", JOptionPane.INFORMATION_MESSAGE);              
        
        } catch (Exception e) {
            System.out.println(e.toString());
        }       
       
       
        JOptionPane.showMessageDialog(null, "WSQ file was loaded into memory stream and decompressed into another memory stream.\nNow please press button \"stream -> WSQ\" to compress memory stream and save it to file.\nWSQ compressed byte array was converted to HBITMAP for showing on screen.", "WSQ Image Library", JOptionPane.INFORMATION_MESSAGE);      

        buttonstream_to_wsq.setEnabled(true);
        
        } catch (Exception e) {
            System.out.println(e.toString());
        }
    }//GEN-LAST:event_buttonwsq_to_streamActionPerformed

    private void buttonRegisterActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonRegisterActionPerformed
        System.out.println("button register action");

// "RegisterWSQ64.exe" and "WSQ image library (for Windows 64-bit)" were compiled using Microsoft Visual C++ 2008 version compiler.
// If it fails to run then you need to install Microsoft Visual C++ 2008 Redistributable Package (x64).
// The download link is:
// https://www.microsoft.com/en-us/download/details.aspx?id=26368
// Microsoft Visual C++ 2008 Redistributable Package (x64)
        
        WSQ_Demo.RegisterWSQ();
    }//GEN-LAST:event_buttonRegisterActionPerformed


    private void buttonSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonSaveActionPerformed
        System.out.println("button save action");
        
        JFileChooser saveDlg = new JFileChooser();
        
        saveDlg.setCurrentDirectory(new File(lastSaveFolder));
		saveDlg.setFileFilter(WSQ_Filter);
 		saveDlg.addChoosableFileFilter(BMP_Filter);
		saveDlg.addChoosableFileFilter(TIF_Filter);
		saveDlg.addChoosableFileFilter(PNG_Filter);
		saveDlg.addChoosableFileFilter(JPG_Filter);
		saveDlg.addChoosableFileFilter(TGA_Filter);		
		saveDlg.addChoosableFileFilter(JP2_Filter);
		saveDlg.addChoosableFileFilter(JPC_Filter);
		saveDlg.addChoosableFileFilter(PBM_Filter);
		saveDlg.addChoosableFileFilter(PGM_Filter);
		saveDlg.addChoosableFileFilter(PPM_Filter);
		saveDlg.addChoosableFileFilter(GIF_Filter);
		saveDlg.addChoosableFileFilter(PNM_Filter);
		saveDlg.addChoosableFileFilter(RAS_Filter);
		saveDlg.addChoosableFileFilter(MNG_Filter);					
		saveDlg.addChoosableFileFilter(PCX_Filter);
		
	   
        int dialogResult = saveDlg.showSaveDialog(this);
        
        if(dialogResult != JFileChooser.APPROVE_OPTION) {
            return;
        }
     
        lastSaveFolder = saveDlg.getSelectedFile().getParent();       
        String fileName = saveDlg.getSelectedFile().getAbsolutePath();
            
		
        int type = 1;
		
		javax.swing.filechooser.FileFilter fileExtFilter = saveDlg.getFileFilter();
		FileNameExtensionFilter fileNameExtensionFilter = (FileNameExtensionFilter) fileExtFilter;
		String ext = fileNameExtensionFilter.getExtensions()[0];
//		System.out.println(ext);		
		
        if (fileExtFilter == null) {type = 1;}
        else if (ext == "wsq") {type = 1;}
        else if (ext == "bmp") {type = 2;}
        else if (ext == "tif") {type = 3;}
        else if (ext == "png") {type = 4;}
        else if (ext == "jpg") {type = 5;}
        else if (ext == "tga") {type = 6;}
        else if (ext == "rgb") {type = 7;}
        else if (ext == "jp2") {type = 8;}
        else if (ext == "jpc") {type = 9;}
        else if (ext == "pbm") {type = 10;}
        else if (ext == "pgm") {type = 11;}
        else if (ext == "ppm") {type = 12;}
        else if (ext == "gif") {type = 13;}
        else if (ext == "pnm") {type = 14;}
        else if (ext == "ras") {type = 15;}
        else if (ext == "mng") {type = 16;}
        else if (ext == "pcx") {type = 17;}
	
        
        int width = m_image.getWidth();
        int height = m_image.getHeight();
        
        System.out.println("image width = " + width + ", height = " + height + ", type = " + type);
        
        Raster raster = m_image.getData();
        DataBuffer db = raster.getDataBuffer();
        DataBufferInt dbi = (DataBufferInt)db;
        if (dbi == null) {
            System.out.println("Error: unable to cast to DataBufferInt");
            return;
        }       
        
        int[] pixels = dbi.getData();       
        
        WSQ_Demo.SaveBMPToFile(pixels, width, height, fileName, type);
    }//GEN-LAST:event_buttonSaveActionPerformed

    private void buttonOpenActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonOpenActionPerformed
        System.out.println("button open action");
        
        JFileChooser openDlg = new JFileChooser();
        openDlg.setCurrentDirectory(new File(lastOpenFolder));
		
		openDlg.addChoosableFileFilter(WSQ_Filter);		
 		openDlg.addChoosableFileFilter(BMP_Filter);
		openDlg.addChoosableFileFilter(TIFF_Filter);
		openDlg.addChoosableFileFilter(TIF_Filter);
		openDlg.addChoosableFileFilter(JPEG_Filter);
		openDlg.addChoosableFileFilter(JPG_Filter);
		openDlg.addChoosableFileFilter(JP2_Filter);
		openDlg.addChoosableFileFilter(JPC_Filter);
		openDlg.addChoosableFileFilter(PNG_Filter);
		openDlg.addChoosableFileFilter(GIF_Filter);
		openDlg.addChoosableFileFilter(TGA_Filter);
		openDlg.addChoosableFileFilter(PCX_Filter);
		openDlg.addChoosableFileFilter(ICO_Filter);
		openDlg.addChoosableFileFilter(WMF_Filter);
		openDlg.addChoosableFileFilter(EMF_Filter);
		openDlg.addChoosableFileFilter(WBM_Filter);
		openDlg.addChoosableFileFilter(WBMP_Filter);
		openDlg.addChoosableFileFilter(SKA_Filter);
		openDlg.addChoosableFileFilter(MNG_Filter);
		openDlg.addChoosableFileFilter(JNG_Filter);
		openDlg.addChoosableFileFilter(PNM_Filter);
		openDlg.addChoosableFileFilter(PBM_Filter);
		openDlg.addChoosableFileFilter(PGM_Filter);
		openDlg.addChoosableFileFilter(PPM_Filter);
		openDlg.addChoosableFileFilter(RAS_Filter);
		openDlg.addChoosableFileFilter(RAW_Filter);
		openDlg.addChoosableFileFilter(CRW_Filter);
		openDlg.addChoosableFileFilter(CR2_Filter);
		openDlg.addChoosableFileFilter(DNG_Filter);
		openDlg.addChoosableFileFilter(ARW_Filter);
		openDlg.addChoosableFileFilter(ERF_Filter);
		openDlg.addChoosableFileFilter(F3FR_Filter);
		openDlg.addChoosableFileFilter(DCRF_Filter);
		openDlg.addChoosableFileFilter(X3F_Filter);
		openDlg.addChoosableFileFilter(MEF_Filter);
		openDlg.addChoosableFileFilter(RAF_Filter);
		openDlg.addChoosableFileFilter(MRW_Filter);
		openDlg.addChoosableFileFilter(PEF_Filter);
		openDlg.addChoosableFileFilter(SR2_Filter);
		openDlg.addChoosableFileFilter(ORF_Filter);
		openDlg.setFileFilter(All_Images_Filter);
		
      
        
        int dialogResult = openDlg.showOpenDialog(this);
        
        if(dialogResult != JFileChooser.APPROVE_OPTION) {
            return;
        }
        lastOpenFolder = openDlg.getSelectedFile().getParent();
        String fileName = openDlg.getSelectedFile().getAbsolutePath();
        

        
        Integer width = 0;
        Integer height = 0;
        
        
        dimension[0] = 0;
        dimension[1] = 0;
        data = WSQ_Demo.CreateBMPFromFile(dimension, fileName);
        
        width = dimension[0];
        height = dimension[1];
        
        try {       
        
        dataBuffer = new DataBufferInt(data, data.length);
        
        WritableRaster writableRaster = Raster.createPackedRaster(dataBuffer, width, height, width, bandMasks, null);
        m_image = new BufferedImage(colorModel, writableRaster, true, null);
        javax.swing.ImageIcon ii = new javax.swing.ImageIcon(m_image);
        m_label.setIcon(ii);
        
        comment_text = WSQ_Demo.ReadWSQ_comment();   
        System.out.println("width = " + width + ", height = " + height + ", ppi = " + ppi + ", comment_text = " + comment_text);        
        
        
        buttonSave.setEnabled(true);
        
      
        
        } catch (Exception e) {
            System.out.println(e.toString());
        }
    }//GEN-LAST:event_buttonOpenActionPerformed

    WSQ_Demo m_wsqDemo = null;
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new NewJDialog(new javax.swing.JFrame(), true).setVisible(true);
            }
        });
    }
    
    BufferedImage m_image = null;
    String lastSaveFolder = "";
    String lastOpenFolder = "";
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton buttonOpen;
    private javax.swing.JButton buttonRegister;
    private javax.swing.JButton buttonSave;
    private javax.swing.JButton buttonstream_to_wsq;
    private javax.swing.JButton buttonwsq_to_stream;
    private javax.swing.JFrame jFrame1;
    private javax.swing.JLabel m_label;
    // End of variables declaration//GEN-END:variables
    
}
